/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.44 Revision 1.61
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.44 2006/09/21 03:06:18 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.61 2007/01/04 14:56:46 flameeyes Exp $
4# 4#
5# Author: Diego Pettenò <flameeyes@gentoo.org> 5# Author: Diego Pettenò <flameeyes@gentoo.org>
6# Enhancements: Martin Schlemmer <azarah@gentoo.org> 6# Enhancements: Martin Schlemmer <azarah@gentoo.org>
7# 7#
8# This eclass is for handling autotooled software packages that 8# This eclass is for handling autotooled software packages that
12 12
13inherit eutils libtool 13inherit eutils libtool
14 14
15_automake_atom="sys-devel/automake" 15_automake_atom="sys-devel/automake"
16_autoconf_atom="sys-devel/autoconf" 16_autoconf_atom="sys-devel/autoconf"
17if [[ -n ${WANT_AUTOMAKE} ]]; then
18 case ${WANT_AUTOMAKE} in
19 # workaround while we have different versions of automake in arch and ~arch
20 latest) _automake_atom="|| ( =sys-devel/automake-1.10* =sys-devel/automake-1.9* )" ;;
17[[ -n ${WANT_AUTOMAKE} ]] && _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" 21 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
22 esac
23fi
24
18if [[ -n ${WANT_AUTOCONF} ]]; then 25if [[ -n ${WANT_AUTOCONF} ]] ; then
19 case ${WANT_AUTOCONF} in 26 case ${WANT_AUTOCONF} in
20 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 27 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
21 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;; 28 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;;
22 esac 29 esac
23fi 30fi
24DEPEND="${_automake_atom} 31DEPEND="${_automake_atom}
25 ${_autoconf_atom} 32 ${_autoconf_atom}
26 sys-devel/libtool" 33 sys-devel/libtool"
34RDEPEND=""
27unset _automake_atom _autoconf_atom 35unset _automake_atom _autoconf_atom
28 36
29# Variables: 37# Variables:
30# 38#
31# AT_M4DIR - Additional director(y|ies) aclocal should search 39# AT_M4DIR - Additional director(y|ies) aclocal should search
32# AM_OPTS - Additional options to pass to automake during 40# AM_OPTS - Additional options to pass to automake during
33# eautoreconf call. 41# eautoreconf call.
42# AT_NOELIBTOOLIZE - Don't run elibtoolize command if set to 'yes',
43# useful when elibtoolize needs to be ran with
44# particular options
34 45
35# Functions: 46# Functions:
36# 47#
37# eautoreconf() - Should do a full autoreconf - normally what most people 48# eautoreconf() - Should do a full autoreconf - normally what most people
38# will be interested in. Also should handle additional 49# will be interested in. Also should handle additional
106 ;; 117 ;;
107 esac 118 esac
108 done 119 done
109 fi 120 fi
110 121
122 autotools_set_versions
111 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 123 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
112 autotools_run_tool aclocal "$@" ${aclocal_opts} 124 autotools_run_tool aclocal "$@" ${aclocal_opts}
113} 125}
114 126
115_elibtoolize() { 127_elibtoolize() {
131} 143}
132 144
133eautoheader() { 145eautoheader() {
134 # Check if we should run autoheader 146 # Check if we should run autoheader
135 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 147 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
148 autotools_set_versions
136 autotools_run_tool autoheader "$@" 149 NO_FAIL=1 autotools_run_tool autoheader "$@"
137} 150}
138 151
139eautoconf() { 152eautoconf() {
140 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 153 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
141 echo 154 echo
142 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!" 155 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!"
143 echo 156 echo
144 die "No configure.{ac,in} present!" 157 die "No configure.{ac,in} present!"
145 fi 158 fi
146 159
160 autotools_set_versions
147 autotools_run_tool autoconf "$@" 161 autotools_run_tool autoconf "$@"
148} 162}
149 163
150eautomake() { 164eautomake() {
151 local extra_opts 165 local extra_opts
152 166
153 [[ -f Makefile.am ]] || return 0 167 [[ -f Makefile.am ]] || return 0
154 168
155 if [[ -n ${WANT_AUTOMAKE} ]]; then 169 autotools_set_versions
156 export WANT_AUTOMAKE # let the automake wrapper pick it up
157 einfo "Required automake ${WANT_AUTOMAKE}. Using $(automake --version | head -n 1)."
158 fi
159
160 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then 170 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then
161 local used_automake 171 local used_automake
162 local installed_automake 172 local installed_automake
163 173
164 installed_automake=$(automake --version | head -n 1 | \ 174 installed_automake=$(automake --version | head -n 1 | \
179 189
180 # --force-missing seems not to be recognized by some flavours of automake 190 # --force-missing seems not to be recognized by some flavours of automake
181 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 191 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
182} 192}
183 193
194autotools_set_versions() {
195 [[ -n ${autotools_version_sets} ]] && return 0
184 196
197 if [[ -n ${WANT_AUTOCONF} ]]; then
198 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5"
199 export WANT_AUTOCONF
200 einfo "Requested autoconf ${WANT_AUTOCONF}"
201 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)"
202 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)"
203 else
204 ewarn "QA Notice: \${WANT_AUTOCONF} variable unset. Please report on http://bugs.gentoo.org/"
205 fi
206
207 if [[ -n ${WANT_AUTOMAKE} ]]; then
208 local latest_automake
209 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
210 latest_automake="latest: "
211 for amver in 1.10 1.9 1.8 1.7 1.6; do
212 WANT_AUTOMAKE="${amver}"
213 ROOT=/ has_version =sys-devel/automake-${amver}* && break
214 done
215 fi
216 export WANT_AUTOMAKE
217 einfo "Requested automake ${latest_automake}${WANT_AUTOMAKE}"
218 einfo "Using $(automake --version 2>/dev/null | head -n 1)"
219 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)"
220 else
221 ewarn "QA Notice: \${WANT_AUTOMAKE} variable unset. Please report on http://bugs.gentoo.org/"
222 fi
223
224 autotools_version_sets="yes"
225}
185 226
186# Internal function to run an autotools' tool 227# Internal function to run an autotools' tool
187autotools_run_tool() { 228autotools_run_tool() {
188 local STDERR_TARGET="${T}/$$.out" 229 local STDERR_TARGET="${T}/$$.out"
189 local PATCH_TARGET="${T}/$$.patch"
190 local ris 230 local ris
191 231
192 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 232 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
193 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 233 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
194 234
195 ebegin "Running $@" 235 ebegin "Running $@"
196 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1 236 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1
197 ris=$? 237 ris=$?
198 eend ${ris} 238 eend ${ris}
199 239
200 if [[ ${ris} != 0 ]]; then 240 if [[ ${ris} != 0 && ${NO_FAIL} != 1 ]]; then
201 echo 241 echo
202 eerror "Failed Running $1 !" 242 eerror "Failed Running $1 !"
203 eerror 243 eerror
204 eerror "Include in your bugreport the contents of:" 244 eerror "Include in your bugreport the contents of:"
205 eerror 245 eerror

Legend:
Removed from v.1.44  
changed lines
  Added in v.1.61

  ViewVC Help
Powered by ViewVC 1.1.20